-module(purity_bifs).

-export([is_pure/3, is_known/3]).
-export([is_pure/2, is_known/2]).
-export([is_pure/1, is_known/1]).

-spec is_pure(atom(), atom(), arity()) -> purity:pure() | unknown.

is_pure(erlang,apply,2) -> 
    {e, [{arg,1}]};
is_pure(erlang,spawn,1) -> 
    {s,[]};
is_pure(erlang,spawn,4) -> 
    {s,[]};
is_pure(erlang,integer_to_list,2) -> 
    {e, [{remote,{erlang,integer_to_list,1},[]}]};
is_pure(erlang,list_to_integer,2) -> 
    {e, [{remote,{erlang,list_to_integer,1},[]}]};
is_pure(erlang,localtime_to_universaltime,1) -> 
    {d, [{remote,{erlang,localtime_to_universaltime,2},[]}]};
is_pure(erlang,max,2) -> 
    {p,[]};
is_pure(erlang,min,2) -> 
    {p,[]};
is_pure(io_lib,format,2) -> 
    {e,[]};
is_pure(binary,at,2) -> 
    {e,[]};
is_pure(binary,bin_to_list,1) -> 
    {e,[]};
is_pure(binary,bin_to_list,2) -> 
    {e,[]};
is_pure(binary,bin_to_list,3) -> 
    {e,[]};
is_pure(binary,compile_pattern,1) -> 
    {e,[]};
is_pure(code,get_chunk,2) -> 
    {s,[]};
is_pure(code,is_module_native,1) -> 
    {d,[]};
is_pure(code,make_stub_module,3) -> 
    {s,[]};
is_pure(code,module_md5,1) -> 
    {d,[]};
is_pure(erlang,'-',1) -> 
    {e,[]};
is_pure(erlang,'+',1) -> 
    {e,[]};
is_pure(erlang,'<',2) -> 
    {p,[]};
is_pure(erlang,'=<',2) -> 
    {p,[]};
is_pure(erlang,'==',2) -> 
    {p,[]};
is_pure(erlang,'=:=',2) -> 
    {p,[]};
is_pure(erlang,'=/=',2) -> 
    {p,[]};
is_pure(erlang,'>=',2) -> 
    {p,[]};
is_pure(erlang,'>',2) -> 
    {p,[]};
is_pure(erlang,'--',2) -> 
    {e,[]};
is_pure(erlang,'-',2) -> 
    {e,[]};
is_pure(erlang,'/=',2) -> 
    {p,[]};
is_pure(erlang,'/',2) -> 
    {e,[]};
is_pure(erlang,'!',2) -> 
    {s,[]};
is_pure(erlang,'*',2) -> 
    {e,[]};
is_pure(erlang,'+',2) -> 
    {e,[]};
is_pure(erlang,'++',2) -> 
    {e,[]};
is_pure(erlang,abs,1) -> 
    {e,[]};
is_pure(erlang,adler32,1) -> 
    {e,[]};
is_pure(erlang,adler32,2) -> 
    {e,[]};
is_pure(erlang,adler32_combine,3) -> 
    {e,[]};
is_pure(erlang,'and',2) -> 
    {e,[]};
is_pure(erlang,append,2) -> 
    {e,[]};
is_pure(erlang,append_element,2) -> 
    {e,[]};
is_pure(erlang,apply,3) -> 
    {{at_least,e},[]};
is_pure(erlang,atom_to_binary,2) -> 
    {e,[]};
is_pure(erlang,atom_to_list,1) -> 
    {e,[]};
is_pure(erlang,'band',2) -> 
    {e,[]};
is_pure(erlang,binary_part,2) -> 
    {e,[]};
is_pure(erlang,binary_part,3) -> 
    {e,[]};
is_pure(erlang,binary_to_atom,2) -> 
    {e,[]};
is_pure(erlang,binary_to_existing_atom,2) -> 
    {e,[]};
is_pure(erlang,binary_to_list,1) -> 
    {e,[]};
is_pure(erlang,binary_to_list,3) -> 
    {e,[]};
is_pure(erlang,binary_to_term,1) -> 
    {e,[]};
is_pure(erlang,binary_to_term,2) -> 
    {e,[]};
is_pure(erlang,bit_size,1) -> 
    {e,[]};
is_pure(erlang,bitstring_to_list,1) -> 
    {e,[]};
is_pure(erlang,blocking_read_file,1) -> 
    {d,[]};
is_pure(erlang,'bnot',1) -> 
    {e,[]};
is_pure(erlang,'bor',2) -> 
    {e,[]};
is_pure(erlang,'bsl',2) -> 
    {e,[]};
is_pure(erlang,'bsr',2) -> 
    {e,[]};
is_pure(erlang,bump_reductions,1) -> 
    {s,[]};
is_pure(erlang,'bxor',2) -> 
    {e,[]};
is_pure(erlang,byte_size,1) -> 
    {e,[]};
is_pure(erlang,call_on_load_function,1) -> 
    {s,[]};
is_pure(erlang,cancel_timer,1) -> 
    {s,[]};
is_pure(erlang,check_process_code,2) -> 
    {d,[]};
is_pure(erlang,crc32,1) -> 
    {e,[]};
is_pure(erlang,crc32,2) -> 
    {e,[]};
is_pure(erlang,crc32_combine,3) -> 
    {e,[]};
is_pure(erlang,date,0) -> 
    {d,[]};
is_pure(erlang,decode_packet,3) -> 
    {e,[]};
is_pure(erlang,delete_module,1) -> 
    {s,[]};
is_pure(erlang,demonitor,1) -> 
    {s,[]};
is_pure(erlang,demonitor,2) -> 
    {s,[]};
is_pure(erlang,display,1) -> 
    {s,[]};
is_pure(erlang,display_nl,0) -> 
    {s,[]};
is_pure(erlang,display_string,1) -> 
    {s,[]};
is_pure(erlang,dist_exit,3) -> 
    {s,[]};
is_pure(erlang,'div',2) -> 
    {e,[]};
is_pure(erlang,element,2) -> 
    {e,[]};
is_pure(erlang,erase,0) -> 
    {s,[]};
is_pure(erlang,erase,1) -> 
    {s,[]};
is_pure(erlang,error,1) -> 
    {s,[]};
is_pure(erlang,error,2) -> 
    {s,[]};
is_pure(erlang,nif_error,1) -> 
    {s,[]};
is_pure(erlang,nif_error,2) -> 
    {s,[]};
is_pure(erlang,exit,1) -> 
    {s,[]};
is_pure(erlang,exit,2) -> 
    {s,[]};
is_pure(erlang,external_size,1) -> 
    {p,[]};
is_pure(erlang,finish_after_on_load,2) -> 
    {s,[]};
is_pure(erlang,float,1) -> 
    {e,[]};
is_pure(erlang,float_to_list,1) -> 
    {e,[]};
is_pure(erlang,function_exported,3) -> 
    {d,[]};
is_pure(erlang,fun_info,2) -> 
    {d,[]};
is_pure(erlang,fun_to_list,1) -> 
    {e,[]};
is_pure(erlang,garbage_collect,0) -> 
    {s,[]};
is_pure(erlang,garbage_collect,1) -> 
    {s,[]};
is_pure(erlang,garbage_collect_message_area,0) -> 
    {s,[]};
is_pure(erlang,get,0) -> 
    {d,[]};
is_pure(erlang,get,1) -> 
    {d,[]};
is_pure(erlang,get_keys,1) -> 
    {d,[]};
is_pure(erlang,get_module_info,1) -> 
    {d,[]};
is_pure(erlang,get_module_info,2) -> 
    {d,[]};
is_pure(erlang,get_stacktrace,0) -> 
    {d,[]};
is_pure(erlang,group_leader,0) -> 
    {d,[]};
is_pure(erlang,group_leader,2) -> 
    {s,[]};
is_pure(erlang,halt,0) -> 
    {s,[]};
is_pure(erlang,halt,1) -> 
    {s,[]};
is_pure(erlang,hash,2) -> 
    {e,[]};
is_pure(erlang,hd,1) -> 
    {e,[]};
is_pure(erlang,hibernate,3) -> 
    {s,[]};
is_pure(erlang,integer_to_list,1) -> 
    {e,[]};
is_pure(erlang,iolist_size,1) -> 
    {e,[]};
is_pure(erlang,iolist_to_binary,1) -> 
    {e,[]};
is_pure(erlang,is_alive,0) -> 
    {d,[]};
is_pure(erlang,is_atom,1) -> 
    {p,[]};
is_pure(erlang,is_binary,1) -> 
    {p,[]};
is_pure(erlang,is_bitstring,1) -> 
    {p,[]};
is_pure(erlang,is_boolean,1) -> 
    {p,[]};
is_pure(erlang,is_builtin,3) -> 
    {e,[]};
is_pure(erlang,is_float,1) -> 
    {p,[]};
is_pure(erlang,is_function,1) -> 
    {p,[]};
is_pure(erlang,is_function,2) -> 
    {e,[]};
is_pure(erlang,is_integer,1) -> 
    {p,[]};
is_pure(erlang,is_list,1) -> 
    {p,[]};
is_pure(erlang,is_number,1) -> 
    {p,[]};
is_pure(erlang,is_pid,1) -> 
    {p,[]};
is_pure(erlang,is_port,1) -> 
    {p,[]};
is_pure(erlang,is_process_alive,1) -> 
    {d,[]};
is_pure(erlang,is_record,2) -> 
    {p,[]};
is_pure(erlang,is_record,3) -> 
    {p,[]};
is_pure(erlang,is_reference,1) -> 
    {p,[]};
is_pure(erlang,is_tuple,1) -> 
    {p,[]};
is_pure(erlang,length,1) -> 
    {e,[]};
is_pure(erlang,link,1) -> 
    {s,[]};
is_pure(erlang,list_to_atom,1) -> 
    {e,[]};
is_pure(erlang,list_to_binary,1) -> 
    {e,[]};
is_pure(erlang,list_to_bitstring,1) -> 
    {e,[]};
is_pure(erlang,list_to_existing_atom,1) -> 
    {e,[]};
is_pure(erlang,list_to_float,1) -> 
    {e,[]};
is_pure(erlang,list_to_integer,1) -> 
    {e,[]};
is_pure(erlang,list_to_pid,1) -> 
    {e,[]};
is_pure(erlang,list_to_tuple,1) -> 
    {e,[]};
is_pure(erlang,loaded,0) -> 
    {d,[]};
is_pure(erlang,load_module,2) -> 
    {s,[]};
is_pure(erlang,load_nif,2) -> 
    {s,[]};
is_pure(erlang,localtime,0) -> 
    {d,[]};
is_pure(erlang,localtime_to_universaltime,2) -> 
    {d,[]};
is_pure(erlang,make_fun,3) -> 
    {e,[]};
is_pure(erlang,make_ref,0) -> 
    {s,[]};
is_pure(erlang,make_tuple,2) -> 
    {e,[]};
is_pure(erlang,make_tuple,3) -> 
    {e,[]};
is_pure(erlang,match_spec_test,3) -> 
    {s,[]};
is_pure(erlang,md5,1) -> 
    {e,[]};
is_pure(erlang,md5_final,1) -> 
    {e,[]};
is_pure(erlang,md5_init,0) -> 
    {e,[]};
is_pure(erlang,md5_update,2) -> 
    {e,[]};
is_pure(erlang,memory,0) -> 
    {d,[]};
is_pure(erlang,memory,1) -> 
    {d,[]};
is_pure(erlang,module_loaded,1) -> 
    {d,[]};
is_pure(erlang,monitor,2) -> 
    {s,[]};
is_pure(erlang,monitor_node,2) -> 
    {s,[]};
is_pure(erlang,monitor_node,3) -> 
    {s,[]};
is_pure(erlang,node,0) -> 
    {d,[]};
is_pure(erlang,node,1) -> 
    {d,[]};
is_pure(erlang,nodes,1) -> 
    {d,[]};
is_pure(erlang,'not',1) -> 
    {e,[]};
is_pure(erlang,now,0) -> 
    {d,[]};
is_pure(erlang,open_port,2) -> 
    {s,[]};
is_pure(erlang,'or',2) -> 
    {e,[]};
is_pure(erlang,phash,2) -> 
    {e,[]};
is_pure(erlang,phash2,1) -> 
    {e,[]};
is_pure(erlang,phash2,2) -> 
    {e,[]};
is_pure(erlang,pid_to_list,1) -> 
    {e,[]};
is_pure(erlang,port_call,2) -> 
    {s,[]};
is_pure(erlang,port_call,3) -> 
    {s,[]};
is_pure(erlang,port_close,1) -> 
    {s,[]};
is_pure(erlang,port_command,2) -> 
    {s,[]};
is_pure(erlang,port_command,3) -> 
    {s,[]};
is_pure(erlang,port_connect,2) -> 
    {s,[]};
is_pure(erlang,port_control,3) -> 
    {s,[]};
is_pure(erlang,port_get_data,1) -> 
    {s,[]};
is_pure(erlang,port_info,1) -> 
    {d,[]};
is_pure(erlang,port_info,2) -> 
    {d,[]};
is_pure(erlang,ports,0) -> 
    {d,[]};
is_pure(erlang,port_set_data,2) -> 
    {s,[]};
is_pure(erlang,port_to_list,1) -> 
    {e,[]};
is_pure(erlang,pre_loaded,0) -> 
    {d,[]};
is_pure(erlang,process_display,2) -> 
    {s,[]};
is_pure(erlang,processes,0) -> 
    {d,[]};
is_pure(erlang,process_flag,2) -> 
    {s,[]};
is_pure(erlang,process_flag,3) -> 
    {s,[]};
is_pure(erlang,process_info,1) -> 
    {d,[]};
is_pure(erlang,process_info,2) -> 
    {d,[]};
is_pure(erlang,purge_module,1) -> 
    {s,[]};
is_pure(erlang,put,2) -> 
    {s,[]};
is_pure(erlang,raise,3) -> 
    {s,[]};
is_pure(erlang,read_timer,1) -> 
    {d,[]};
is_pure(erlang,ref_to_list,1) -> 
    {e,[]};
is_pure(erlang,register,2) -> 
    {s,[]};
is_pure(erlang,registered,0) -> 
    {d,[]};
is_pure(erlang,'rem',2) -> 
    {e,[]};
is_pure(erlang,resume_process,1) -> 
    {s,[]};
is_pure(erlang,round,1) -> 
    {e,[]};
is_pure(erlang,self,0) -> 
    {d,[]};
is_pure(erlang,send,2) -> 
    {s,[]};
is_pure(erlang,send,3) -> 
    {s,[]};
is_pure(erlang,send_after,3) -> 
    {s,[]};
is_pure(erlang,seq_trace,2) -> 
    {s,[]};
is_pure(erlang,seq_trace_info,1) -> 
    {d,[]};
is_pure(erlang,seq_trace_print,1) -> 
    {s,[]};
is_pure(erlang,seq_trace_print,2) -> 
    {s,[]};
is_pure(erlang,setelement,3) -> 
    {e,[]};
is_pure(erlang,setnode,2) -> 
    {s,[]};
is_pure(erlang,setnode,3) -> 
    {s,[]};
is_pure(erlang,size,1) -> 
    {e,[]};
is_pure(erlang,spawn,3) -> 
    {s,[]};
is_pure(erlang,spawn_link,3) -> 
    {s,[]};
is_pure(erlang,spawn_opt,1) -> 
    {s,[]};
is_pure(erlang,split_binary,2) -> 
    {e,[]};
is_pure(erlang,start_timer,3) -> 
    {s,[]};
is_pure(erlang,statistics,1) -> 
    {s,[]};
is_pure(erlang,subtract,2) -> 
    {e,[]};
is_pure(erlang,suspend_process,2) -> 
    {s,[]};
is_pure(erlang,system_flag,2) -> 
    {s,[]};
is_pure(erlang,system_info,1) -> 
    {d,[]};
is_pure(erlang,system_monitor,0) -> 
    {d,[]};
is_pure(erlang,system_monitor,1) -> 
    {s,[]};
is_pure(erlang,system_monitor,2) -> 
    {s,[]};
is_pure(erlang,system_profile,0) -> 
    {d,[]};
is_pure(erlang,system_profile,2) -> 
    {s,[]};
is_pure(erlang,term_to_binary,1) -> 
    {e,[]};
is_pure(erlang,term_to_binary,2) -> 
    {e,[]};
is_pure(erlang,throw,1) -> 
    {s,[]};
is_pure(erlang,time,0) -> 
    {d,[]};
is_pure(erlang,tl,1) -> 
    {e,[]};
is_pure(erlang,trace,3) -> 
    {s,[]};
is_pure(erlang,trace_delivered,1) -> 
    {s,[]};
is_pure(erlang,trace_info,2) -> 
    {d,[]};
is_pure(erlang,trace_pattern,2) -> 
    {s,[]};
is_pure(erlang,trace_pattern,3) -> 
    {s,[]};
is_pure(erlang,trunc,1) -> 
    {e,[]};
is_pure(erlang,tuple_size,1) -> 
    {e,[]};
is_pure(erlang,tuple_to_list,1) -> 
    {e,[]};
is_pure(erlang,universaltime,0) -> 
    {d,[]};
is_pure(erlang,universaltime_to_localtime,1) -> 
    {d,[]};
is_pure(erlang,unlink,1) -> 
    {s,[]};
is_pure(erlang,unregister,1) -> 
    {s,[]};
is_pure(erlang,whereis,1) -> 
    {d,[]};
is_pure(erlang,'xor',2) -> 
    {e,[]};
is_pure(erl_ddll,demonitor,1) -> 
    {s,[]};
is_pure(erl_ddll,format_error_int,1) -> 
    {s,[]};
is_pure(erl_ddll,info,2) -> 
    {d,[]};
is_pure(erl_ddll,loaded_drivers,0) -> 
    {d,[]};
is_pure(erl_ddll,monitor,2) -> 
    {s,[]};
is_pure(erl_ddll,try_load,3) -> 
    {s,[]};
is_pure(erl_ddll,try_unload,2) -> 
    {s,[]};
is_pure(error_logger,warning_map,0) -> 
    {d,[]};
is_pure(erts_debug,breakpoint,2) -> 
    {s,[]};
is_pure(erts_debug,disassemble,1) -> 
    {s,[]};
is_pure(erts_debug,display,1) -> 
    {s,[]};
is_pure(erts_debug,dist_ext_to_term,2) -> 
    {s,[]};
is_pure(erts_debug,dump_links,1) -> 
    {s,[]};
is_pure(erts_debug,dump_monitors,1) -> 
    {s,[]};
is_pure(erts_debug,flat_size,1) -> 
    {p,[]};
is_pure(erts_debug,get_internal_state,1) -> 
    {d,[]};
is_pure(erts_debug,lock_counters,1) -> 
    {s,[]};
is_pure(erts_debug,same,2) -> 
    {p,[]};
is_pure(erts_debug,set_internal_state,2) -> 
    {s,[]};
is_pure(ets,all,0) -> 
    {d,[]};
is_pure(ets,delete,1) -> 
    {s,[]};
is_pure(ets,delete,2) -> 
    {s,[]};
is_pure(ets,delete_all_objects,1) -> 
    {s,[]};
is_pure(ets,delete_object,2) -> 
    {s,[]};
is_pure(ets,first,1) -> 
    {d,[]};
is_pure(ets,give_away,3) -> 
    {s,[]};
is_pure(ets,info,1) -> 
    {d,[]};
is_pure(ets,info,2) -> 
    {d,[]};
is_pure(ets,insert,2) -> 
    {s,[]};
is_pure(ets,insert_new,2) -> 
    {s,[]};
is_pure(ets,is_compiled_ms,1) -> 
    {p,[]};
is_pure(ets,last,1) -> 
    {d,[]};
is_pure(ets,lookup,2) -> 
    {d,[]};
is_pure(ets,lookup_element,3) -> 
    {d,[]};
is_pure(ets,match,1) -> 
    {d,[]};
is_pure(ets,match,2) -> 
    {d,[]};
is_pure(ets,match,3) -> 
    {d,[]};
is_pure(ets,match_object,1) -> 
    {d,[]};
is_pure(ets,match_object,2) -> 
    {d,[]};
is_pure(ets,match_object,3) -> 
    {d,[]};
is_pure(ets,match_spec_compile,1) -> 
    {e,[]};
is_pure(ets,match_spec_run_r,3) -> 
    {e,[]};
is_pure(ets,member,2) -> 
    {d,[]};
is_pure(ets,new,2) -> 
    {s,[]};
is_pure(ets,next,2) -> 
    {d,[]};
is_pure(ets,prev,2) -> 
    {d,[]};
is_pure(ets,rename,2) -> 
    {s,[]};
is_pure(ets,safe_fixtable,2) -> 
    {s,[]};
is_pure(ets,select,1) -> 
    {d,[]};
is_pure(ets,select,2) -> 
    {d,[]};
is_pure(ets,select,3) -> 
    {d,[]};
is_pure(ets,select_count,2) -> 
    {d,[]};
is_pure(ets,select_delete,2) -> 
    {s,[]};
is_pure(ets,select_reverse,1) -> 
    {d,[]};
is_pure(ets,select_reverse,2) -> 
    {d,[]};
is_pure(ets,select_reverse,3) -> 
    {d,[]};
is_pure(ets,setopts,2) -> 
    {s,[]};
is_pure(ets,slot,2) -> 
    {d,[]};
is_pure(ets,update_counter,3) -> 
    {s,[]};
is_pure(ets,update_element,3) -> 
    {s,[]};
is_pure(lists,keyfind,3) -> 
    {e,[]};
is_pure(lists,keymember,3) -> 
    {e,[]};
is_pure(lists,keysearch,3) -> 
    {e,[]};
is_pure(lists,member,2) -> 
    {e,[]};
is_pure(lists,reverse,2) -> 
    {e,[]};
is_pure(math,acos,1) -> 
    {e,[]};
is_pure(math,acosh,1) -> 
    {e,[]};
is_pure(math,asin,1) -> 
    {e,[]};
is_pure(math,asinh,1) -> 
    {e,[]};
is_pure(math,atan,1) -> 
    {e,[]};
is_pure(math,atan2,2) -> 
    {e,[]};
is_pure(math,atanh,1) -> 
    {e,[]};
is_pure(math,cos,1) -> 
    {e,[]};
is_pure(math,cosh,1) -> 
    {e,[]};
is_pure(math,erf,1) -> 
    {e,[]};
is_pure(math,erfc,1) -> 
    {e,[]};
is_pure(math,exp,1) -> 
    {e,[]};
is_pure(math,log,1) -> 
    {e,[]};
is_pure(math,log10,1) -> 
    {e,[]};
is_pure(math,pow,2) -> 
    {e,[]};
is_pure(math,sin,1) -> 
    {e,[]};
is_pure(math,sinh,1) -> 
    {e,[]};
is_pure(math,sqrt,1) -> 
    {e,[]};
is_pure(math,tan,1) -> 
    {e,[]};
is_pure(math,tanh,1) -> 
    {e,[]};
is_pure(net_kernel,dflag_unicode_io,1) -> 
    {d,[]};
is_pure(os,getenv,0) -> 
    {d,[]};
is_pure(os,getenv,1) -> 
    {d,[]};
is_pure(os,getpid,0) -> 
    {d,[]};
is_pure(os,putenv,2) -> 
    {s,[]};
is_pure(os,timestamp,0) -> 
    {d,[]};
is_pure(re,compile,1) -> 
    {e,[]};
is_pure(re,compile,2) -> 
    {e,[]};
is_pure(re,run,2) -> 
    {e,[]};
is_pure(re,run,3) -> 
    {e,[]};
is_pure(string,to_float,1) -> 
    {p,[]};
is_pure(string,to_integer,1) -> 
    {p,[]};
is_pure(unicode,bin_is_7bit,1) -> 
    {p,[]};
is_pure(unicode,characters_to_binary,2) -> 
    {e,[]};
is_pure(unicode,characters_to_list,2) -> 
    {e,[]};
is_pure(M, F, A) when is_atom(M), is_atom(F), A >= 0, A =< 255 ->
  unknown.

-spec is_known(atom(), atom(), arity()) -> boolean().

is_known(M, F, A) ->
  is_pure(M, F, A) =/= unknown.

-spec is_pure(atom(), arity()) -> purity:pure() | unknown.

is_pure(bs_context_to_binary,1) -> 
    {p,[]};
is_pure(bs_init_writable,1) -> 
    {p,[]};
is_pure(match_fail,1) -> 
    {e,[]};
is_pure(raise,2) -> 
    {s,[]};
is_pure(P, A) when is_atom(P), A >= 0, A =< 255 ->
  unknown.

-spec is_known(atom(), arity()) -> boolean().

is_known(P, A) ->
  is_pure(P, A) =/= unknown.


%% Combine the two functions into one for convenience.

-spec is_pure(term()) -> purity:pure() | unknown.

is_pure({M,F,A}) ->
  is_pure(M, F, A);
is_pure({P, A}) ->
  is_pure(P, A);
is_pure(_) ->
  unknown.

-spec is_known(term()) -> boolean().

is_known(BIF) ->
  is_pure(BIF) =/= unknown.

