-module(costest_fib).
-behaviour(costest).
-export([init/0, files/0, inputs/0, components/0, skeleton/1, candidate/1]).

-define(l, 300).
-define(v, 30).

%% =============================================================================
%% Callbacks

init()             -> ok.
files()            -> [?FILE].
inputs()           -> lists:duplicate(?l, ?v).
components()       -> [{fun(N) -> fib(N) end, fib(?v)}].
skeleton([{C, W}]) -> [{farm, [{seq, C}], W}].
candidate([E1])    -> [[{candidate, farm, [{type, mapapp}, {job, [{orig, E1}]}], undefined}]].

%% =============================================================================
%% Business logic

fib(0) -> 0;
fib(1) -> 1;
fib(N) -> fib(N-1) + fib(N-2).
