-module(costest_img_pipe).
-behaviour(costest).
-export([init/0, files/0, inputs/0, components/0, skeleton/1, candidate/1]).

-define(l, 20).
-define(M, costest_img_logic).

%% =============================================================================
%% Callbacks

init() ->
    code:add_path("/home/daniel_h/tool/erl_img-master/ebin").
files() ->
    [?FILE, filename:join(filename:dirname(?FILE), "costest_img_logic.erl")].
inputs() ->
    ?M:imageList(?l).
components() ->
    [{fun(X) -> ?M:readImage(X) end, fun() -> ?M:readImage(xxx) end},
     {fun(X) -> ?M:convertMerge(X) end, fun() -> ?M:convertMerge(?M:readImage(xxx)) end}].
skeleton({[C1, C2], _}) ->
    [{pipe, [{seq, C1}, {seq, C2}]}].
candidate([E1, E2]) ->
    [[{candidate, pipeline, [{type, mapapp}, {stages, [{orig, E1}, {orig, E2}]}], undefined}]].
