% temporary module for testing

-module(input_gen).
-include("referl_paraphrase.hrl").

-export([do/0]).


do()->
    Exprs =  refcore_graph:path({'$gn', root,0}, [file, form, funcl, body]),
    {A1,A2,A3} = now(),
    random:seed(A1, A2, A3),
    Result = [gen_tr_seq(lists:nth(r(length(Exprs)), Exprs), Exprs)
        || _ <- lists:seq(1,r(30)-1)],
    duplicate_one_tr_seq_with_different_num_of_worker(Result).


gen_tr_seq(Expr, Exprs)->
    #tr_seq{node_id = Expr,
           label = string:join(["Label", io_lib:format("~p",[r(1000)])], ""),
           attribs = gen_attribs(),
           comps = [gen_tr_comp(lists:nth(r(length(Exprs)), Exprs))
                    || _ <- lists:seq(1, r(20))]}.

gen_tr_comp(Expr)->
    #comp{node_id = Expr,
          label = string:join(["Label", io_lib:format("~p",[r(1000)])], ""),
          attribs = gen_attribs()}.

gen_attribs()->
    #attrib{num_of_workers = r(100),
            tseqcpu = r(100)*1.1,
            tseqgpu = r(1000),
            tparcpu = r(100),
            tpargpu = r(1000),
            list_length = r(10000)}.

r(I)->
    random:uniform(I).

duplicate_one_tr_seq_with_different_num_of_worker([])->
  [];
duplicate_one_tr_seq_with_different_num_of_worker(Result=[TrSeq|_])->
  #tr_seq{attribs=#attrib{num_of_workers=NumOfWorkers}} = TrSeq,
  [TrSeq#tr_seq{attribs=TrSeq#tr_seq.attribs#attrib{num_of_workers=NumOfWorkers+10}} | Result].

