-module(tstest_embedded).

-compile(export_all).

-spec job(integer()) -> integer().
job(X) ->
    timer:sleep(10),
    X + 1.

bef() ->
    timer:sleep(250),
    ok.

aft() ->
    timer:sleep(500),
    ok.

-spec f1([integer()]) -> [integer()].
f1(L) ->
    bef(),
    [job(X) || X <- L].


-spec f2([integer()]) -> [integer()].
f2(L) ->
    bef(),
    L2 = [job(X) || X <- L],
    aft(),
    L2.

-spec f3([integer()]) -> [integer()].
f3(L) ->
    bef(),
    L2 = [job(X) || X <- L],
    bef(),
    L3 = [job(X) || X <- L2],
    aft(),
    L3.

-spec f4([integer()]) -> [integer()].
f4(L) ->
    bef(),
    L2 =
        case L of 
            [_,_,_] -> [job(X) || X <- L];
            _ ->
                bef(),
                [job(X) || X <- L]
        end,
    aft(),
    L2.


-spec ff1([[integer()]]) -> [[integer()]].
ff1(LL) ->
    lists:map(fun f1/1, LL).

-spec ff2([[integer()]]) -> [[integer()]].
ff2(LL) ->
    [f2(L) || L <- LL].

-spec ff3([[integer()]]) -> [[integer()]].
ff3(LL) ->
    [f3(L) || L <- LL].

-spec ff4([[integer()]]) -> [[integer()]].
ff4(LL) ->
    [f4(L) || L <- LL].
