-module(tstest_maplike).

-compile(export_all).

-spec job1(integer()) -> integer().
job1(X) ->
    timer:sleep(10),
    X + 1.

-spec job2(integer()) -> integer().
job2(X) ->
    timer:sleep(20),
    X + 2.

sleep() ->
    timer:sleep(30),
    ok.

-spec ml1([integer()]) -> [integer()].
ml1([]) ->
    [];
ml1([H|T]) ->
    sleep(),
    [job1(H) | ml1(T)].

%% -spec ml1_ts([integer()]) -> [integer()].
%% ml1_ts([]) ->
%%     [];
%% ml1_ts([H|T]) ->
%%     sleep(),
%%     [ job1(H) |begin ts_receiver ! {s,H}, R = ml1_ts(T),  ts_receiver ! {e,H}, R end].

-spec ml2([integer()]) -> [integer()].
ml2([]) ->
    [];
ml2([H|T]) ->
    sleep(),
    case length(T) of  
        10 -> 
            sleep(), 
            [job1(H) | ml2(T)];
        _ ->
            sleep(), 
            [job2(H) | ml2(T)]
    end.

%% Melinda's example
ml3(_, [], _) ->
	[];
ml3(G, [H|T], F)->
    if G -> S = ml3(G, T, F);
       true -> S = ml3(G, T, F)
    end,
    [H | S].

%% embedded ?
-spec ml4([[integer()]]) -> [[integer()]].
ml4([]) ->
    [];
ml4([H|T]) ->
    sleep(),
    [[job1(X) || X <- H] | ml4(T)].
