-type token() :: {atom(), integer(), any()} | {atom(), integer()}.

-record(rewrite, {
          left                    :: [token()],
          right                   :: [token()],
          in                      :: term(),
          on                      :: term(),
          modifiers = []          :: list(),
          conditions              :: list(),
          type = replace          :: insert | remove | replace | match_only,
          apply                   :: term(),
          next                    :: term()
         }).

-type rulename() :: atom().

-record(rule, {
          signature :: {rulename(), [term()]},
          rewrite  :: #rewrite{}
         }).

-define(Warning(S, A), io:format("[WARNING] " ++ S ++ "~n", A)).

-define(formnode,       {{'$gn',_,_}=N, #form{}}).
-define(formnode(T),    {{'$gn',_,_}=N, #form{type=T}}).
-define(formnode(T, V), {{'$gn',_,_}=N, #form{type=T, tag=V}}).
-define(exprnode,       {{'$gn',_,_}=N, #expr{}}).
-define(exprnode(T),    {{'$gn',_,_}=N, #expr{type=T}}).
-define(exprnode(T, V), {{'$gn',_,_}=N, #expr{type=T, value=V}}).
-define(clausenode(X),  {{'$gn',_,_}=N, #clause{type=X}}).
-define(node,           {{'$gn',_,_}=N, _}).

-define(true, N, true).
-define(false, N, false).
