-module(cost).

-compile(export_all).


c_matrix_example() ->
    %% Cost = {1000, [{{z, 2}, 0.000003}, {{x, 2}, 0.000346}, {{multsum, 2}, 0.000384}, {{y, 2}, 0.145910}, {{mult_seq_1, 2}, 140.511346}]},
    Np  =  16,
    X   =  8,
    {Y, Z} = {4,4},
    L   =  1000,
    Ts1 =  0.000346, %% x cost
    Tw1 =  0.000003, %% z cost
    Tw11 = 0.000346, %% x cost
    Ts2 =  0.145910,
    Tw2 =  0.000384, %% multsum cost
    Ts3 =  140.511346,
    Tw3 =  Ts2, %% y cost

%    Tpar1 = c_farm(Np,Np,L,Tw1), %% farm1
%    Tpar2 = c_farm(X,Np,L,Tw2), %% farm2
%    Tpar3 = c_farm(Np,Np,L,Tw3), %% farm3
%    Tpar4 = c_farm(X, X, L, c_farm((Np-X)*L, Np-X, L, Tw2)*L), %% farm2 farm3
%%    Tpar5 = c_farm(Np-X, Np, L, c_farm(X, Np, L, Tw1)), %% farm1 farm3
%    Tpar6 = c_farm(X, X, L, c_farm((Np-X)*L, (Np-X), L, Tw1)*Tw2/Tw11*L), %% farm1 farm2
%    Tpar7 = c_farm(Np-(Y+Z), Np-(Y+Z), L, c_farm(Y*L, Y, L, c_farm(Z*L, Z, L, Tw1)*Tw2/Tw11*L)*L), %% farm1 farm2 farm3

    Tpar1 = c_farm(Np,Np,L,Tw1), %% farm1
    Tpar2 = c_farm(Np,Np,L,Tw2), %% farm2
    Tpar3 = c_farm(Np,Np,L,Tw3), %% farm3
    Tpar4 = c_farm(Np-X, Np-X, L, c_farm(X*L, X, L, Tw2)), %% farm2 farm3
%    Tpar5 = c_farm(Np-X, Np-X, L, c_farm(X*L, X, L, Tw1)), %% farm1 farm3
    Tpar6 = c_farm(Np-X, Np-X, L, c_farm(X*L, Np-X, L, Tw1)*Tw2/Tw11), %% farm1 farm2
    Tpar7 = c_farm(Np-(Y+Z), Np-(Y+Z), L, c_farm(Y*L, Y, L, c_farm(Z*L*L, Z, L, Tw1)*Tw2/Tw11)), %% farm1 farm2 farm3
    [{farm1, Ts1, Tpar1, Ts1/Tpar1}, {farm2, Ts2, Tpar2, Ts2/Tpar2}, {farm3, Ts3, Tpar3, Ts3/Tpar3},
     {farm2_farm3, Ts3, Tpar4, Ts3/Tpar4}, %{farm1_farm3, Ts3, Tpar5, Ts3/Tpar5}, 
     {farm1_farm2, Ts2, Tpar6, Ts2/Tpar6}, {farm1_farm2_farm3, Ts3, Tpar7, Ts3/Tpar7}].

c_farm(Nw, Np, L, Ts) -> %% hlpp
    (lists:max([t_emitter(Np, Nw, L), Ts/lists:max([Np, Nw]), t_collector(Nw, L)]) + 2*t_copy())*L.

t_copy()->
    0.001.

t_emitter(Np, Nw, L)->
    0.001. %% todo measure it

t_collector(Nw, L) ->
    0.001. %% todo measure it

c_farm_icpp(Nw, Np, L, Tw) ->
    Td = c_distrib(Nw, L), %% dis
    Tg = c_gather(Nw, L),
    %%$tcomp * ceil ( $ninputs / min ($ncores, $nworkers) ) + ($tdist + $tgather) * min ($ncores, $ninputs);
    Tw*ceiling(L/lists:min([Np,Nw])) + (Td + Tg)*lists:min([Np, L]).

c_distrib(Nw, L) ->
    0.01.

c_gather(Nw, L) -> 
    0.01.

ceiling(X) when X < 0 ->
    trunc(X);
ceiling(X) ->
    T = trunc(X),
    case X - T == 0 of
        true -> T;
        false -> T + 1
    end.
