-module(main).
-export([main/2]).

-define(INT_MAX,2147483647).
-define(RAND_MAX,100).
-define(LCG_A,1664525).
-define(LCG_C,1013904223).

index([H|T], 0) -> H;
index([H|T], N) -> index(T, N-1).

rows(MatrixB) -> MatrixB .

mult([],_) -> [];
mult([R|Rows], Cols) -> [ lists:map(fun(X) -> mult_prime(R, X) end, Cols) | mult(Rows, Cols)  ].   

mult_prime(R, C) -> lists:sum( [ A*B   || {A,B} <- lists:zip(R,C)  ] ) . 

cols(MatrixB) -> [ [ index(Row, I) || Row <- MatrixB   ] || I <- lists:seq(0, length(MatrixB)-1) ]  .

randvet(0, _) -> [];
randvet(Ncols, S) ->
  % NewS = (?LCG_A * S + ?LCG_C) rem ?INT_MAX,
  % [NewS rem ?RAND_MAX | randvet(Ncols - 1, NewS)].
  [ 1000 | randvet(Ncols -1 , S) ].

randmat(0, _, _) -> [];
randmat(Nrows, Ncols, S) ->
  [randvet(Ncols, S) | randmat(Nrows - 1, Ncols, S + 1)].

productMat(MatrixA, MatrixB) ->
  mult(rows(MatrixA), cols(MatrixB)).


main(Nrows, S) ->
  % [Head | _] = Args,
  % IsBench = string:equal(Head, 'is_bench'),
  % {ok, [Nrows, S]} = io:fread("", "~d~d"),
  MatrixA = randmat(Nrows, Nrows, S),
  MatrixB = randmat(Nrows, Nrows, S),
  T1 = erlang:now(),
  productMat(MatrixA, MatrixB),
  T2 = erlang:now(),
  Time = timer:now_diff(T2, T1),
  io:format("Time: ~p~n", [Time]).

